Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -33,4 +1415,5 @@
         // Public declarations
         //
+        public bool needf { get { return _innerobj.needf; } set { _innerobj.needf = value; } }
         public bool needfg { get { return _innerobj.needfg; } set { _innerobj.needfg = value; } }
         public bool xupdated { get { return _innerobj.xupdated; } set { _innerobj.xupdated = value; } }
@@ -159,4 +1542,68 @@
 
     /*************************************************************************
+    The subroutine is finite difference variant of MinLBFGSCreate().  It  uses
+    finite differences in order to differentiate target function.
+
+    Description below contains information which is specific to  this function
+    only. We recommend to read comments on MinLBFGSCreate() in  order  to  get
+    more information about creation of LBFGS optimizer.
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>0:
+                    * if given, only leading N elements of X are used
+                    * if not given, automatically determined from size of X
+        M       -   number of corrections in the BFGS scheme of Hessian
+                    approximation update. Recommended value:  3<=M<=7. The smaller
+                    value causes worse convergence, the bigger will  not  cause  a
+                    considerably better convergence, but will cause a fall in  the
+                    performance. M<=N.
+        X       -   starting point, array[0..N-1].
+        DiffStep-   differentiation step, >0
+
+    OUTPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+    NOTES:
+    1. algorithm uses 4-point central formula for differentiation.
+    2. differentiation step along I-th axis is equal to DiffStep*S[I] where
+       S[] is scaling vector which can be set by MinLBFGSSetScale() call.
+    3. we recommend you to use moderate values of  differentiation  step.  Too
+       large step will result in too large truncation  errors, while too small
+       step will result in too large numerical  errors.  1.0E-6  can  be  good
+       value to start with.
+    4. Numerical  differentiation  is   very   inefficient  -   one   gradient
+       calculation needs 4*N function evaluations. This function will work for
+       any N - either small (1...10), moderate (10...100) or  large  (100...).
+       However, performance penalty will be too severe for any N's except  for
+       small ones.
+       We should also say that code which relies on numerical  differentiation
+       is   less  robust  and  precise.  LBFGS  needs  exact  gradient values.
+       Imprecise gradient may slow  down  convergence,  especially  on  highly
+       nonlinear problems.
+       Thus  we  recommend to use this function for fast prototyping on small-
+       dimensional problems only, and to implement analytical gradient as soon
+       as possible.
+
+      -- ALGLIB --
+         Copyright 16.05.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgscreatef(int n, int m, double[] x, double diffstep, out minlbfgsstate state)
+    {
+        state = new minlbfgsstate();
+        minlbfgs.minlbfgscreatef(n, m, x, diffstep, state.innerobj);
+        return;
+    }
+    public static void minlbfgscreatef(int m, double[] x, double diffstep, out minlbfgsstate state)
+    {
+        int n;
+
+        state = new minlbfgsstate();
+        n = ap.len(x);
+        minlbfgs.minlbfgscreatef(n, m, x, diffstep, state.innerobj);
+
+        return;
+    }
+
+    /*************************************************************************
     This function sets stopping conditions for L-BFGS optimization algorithm.
 
@@ -165,6 +1612,9 @@
         EpsG    -   >=0
                     The  subroutine  finishes  its  work   if   the  condition
-                    ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                    G - gradient.
+                    |v|<EpsG is satisfied, where:
+                    * |.| means Euclidian norm
+                    * v - scaled gradient vector, v[i]=g[i]*s[i]
+                    * g - gradient
+                    * s - scaling coefficients set by MinLBFGSSetScale()
         EpsF    -   >=0
                     The  subroutine  finishes  its work if on k+1-th iteration
@@ -173,5 +1623,9 @@
         EpsX    -   >=0
                     The subroutine finishes its work if  on  k+1-th  iteration
-                    the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
+                    the condition |v|<=EpsX is fulfilled, where:
+                    * |.| means Euclidian norm
+                    * v - scaled step vector, v[i]=dx[i]/s[i]
+                    * dx - ste pvector, dx=X(k+1)-X(k)
+                    * s - scaling coefficients set by MinLBFGSSetScale()
         MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
                     iterations is unlimited.
@@ -236,11 +1690,47 @@
 
     /*************************************************************************
-    Modification of the preconditioner:
-    default preconditioner (simple scaling) is used.
+    This function sets scaling coefficients for LBFGS optimizer.
+
+    ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+    size and gradient are scaled before comparison with tolerances).  Scale of
+    the I-th variable is a translation invariant measure of:
+    a) "how large" the variable is
+    b) how large the step should be to make significant changes in the function
+
+    Scaling is also used by finite difference variant of the optimizer  - step
+    along I-th axis is equal to DiffStep*S[I].
+
+    In  most  optimizers  (and  in  the  LBFGS  too)  scaling is NOT a form of
+    preconditioning. It just  affects  stopping  conditions.  You  should  set
+    preconditioner  by  separate  call  to  one  of  the  MinLBFGSSetPrec...()
+    functions.
+
+    There  is  special  preconditioning  mode, however,  which  uses   scaling
+    coefficients to form diagonal preconditioning matrix. You  can  turn  this
+    mode on, if you want.   But  you should understand that scaling is not the
+    same thing as preconditioning - these are two different, although  related
+    forms of tuning solver.
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        S       -   array[N], non-zero scaling coefficients
+                    S[i] may be negative, sign doesn't matter.
+
+      -- ALGLIB --
+         Copyright 14.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgssetscale(minlbfgsstate state, double[] s)
+    {
+
+        minlbfgs.minlbfgssetscale(state.innerobj, s);
+        return;
+    }
+
+    /*************************************************************************
+    Modification  of  the  preconditioner:  default  preconditioner    (simple
+    scaling, same for all elements of X) is used.
 
     INPUT PARAMETERS:
         State   -   structure which stores algorithm state
-
-    After call to this function preconditioner is changed to the default one.
 
     NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
@@ -250,14 +1740,14 @@
          Copyright 13.10.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void minlbfgssetdefaultpreconditioner(minlbfgsstate state)
+    public static void minlbfgssetprecdefault(minlbfgsstate state)
     {
 
-        minlbfgs.minlbfgssetdefaultpreconditioner(state.innerobj);
+        minlbfgs.minlbfgssetprecdefault(state.innerobj);
         return;
     }
 
     /*************************************************************************
-    Modification of the preconditioner:
-    Cholesky factorization of approximate Hessian is used.
+    Modification of the preconditioner: Cholesky factorization of  approximate
+    Hessian is used.
 
     INPUT PARAMETERS:
@@ -275,15 +1765,68 @@
     iterations.
 
-    NOTE 2:  P  should  be nonsingular. Exception will be thrown otherwise. It
-    also should be well conditioned, although only strict  non-singularity  is
-    tested.
+    NOTE 2:  P  should  be nonsingular. Exception will be thrown otherwise.
 
       -- ALGLIB --
          Copyright 13.10.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void minlbfgssetcholeskypreconditioner(minlbfgsstate state, double[,] p, bool isupper)
+    public static void minlbfgssetpreccholesky(minlbfgsstate state, double[,] p, bool isupper)
     {
 
-        minlbfgs.minlbfgssetcholeskypreconditioner(state.innerobj, p, isupper);
+        minlbfgs.minlbfgssetpreccholesky(state.innerobj, p, isupper);
+        return;
+    }
+
+    /*************************************************************************
+    Modification  of  the  preconditioner:  diagonal of approximate Hessian is
+    used.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        D       -   diagonal of the approximate Hessian, array[0..N-1],
+                    (if larger, only leading N elements are used).
+
+    NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
+    iterations.
+
+    NOTE 2: D[i] should be positive. Exception will be thrown otherwise.
+
+    NOTE 3: you should pass diagonal of approximate Hessian - NOT ITS INVERSE.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgssetprecdiag(minlbfgsstate state, double[] d)
+    {
+
+        minlbfgs.minlbfgssetprecdiag(state.innerobj, d);
+        return;
+    }
+
+    /*************************************************************************
+    Modification of the preconditioner: scale-based diagonal preconditioning.
+
+    This preconditioning mode can be useful when you  don't  have  approximate
+    diagonal of Hessian, but you know that your  variables  are  badly  scaled
+    (for  example,  one  variable is in [1,10], and another in [1000,100000]),
+    and most part of the ill-conditioning comes from different scales of vars.
+
+    In this case simple  scale-based  preconditioner,  with H[i] = 1/(s[i]^2),
+    can greatly improve convergence.
+
+    IMPRTANT: you should set scale of your variables  with  MinLBFGSSetScale()
+    call  (before  or after MinLBFGSSetPrecScale() call). Without knowledge of
+    the scale of your variables scale-based preconditioner will be  just  unit
+    matrix.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlbfgssetprecscale(minlbfgsstate state)
+    {
+
+        minlbfgs.minlbfgssetprecscale(state.innerobj);
         return;
     }
@@ -304,4 +1847,6 @@
 
     These functions accept following parameters:
+        func    -   callback which calculates function (or merit function)
+                    value func at given point x
         grad    -   callback which calculates function (or merit function)
                     value func and gradient grad at given point x
@@ -311,4 +1856,35 @@
                     can be null
 
+    NOTES:
+
+    1. This function has two different implementations: one which  uses  exact
+       (analytical) user-supplied gradient,  and one which uses function value
+       only  and  numerically  differentiates  function  in  order  to  obtain
+       gradient.
+
+       Depending  on  the  specific  function  used to create optimizer object
+       (either MinLBFGSCreate() for analytical gradient  or  MinLBFGSCreateF()
+       for numerical differentiation) you should choose appropriate variant of
+       MinLBFGSOptimize() - one  which  accepts  function  AND gradient or one
+       which accepts function ONLY.
+
+       Be careful to choose variant of MinLBFGSOptimize() which corresponds to
+       your optimization scheme! Table below lists different  combinations  of
+       callback (function/gradient) passed to MinLBFGSOptimize()  and specific
+       function used to create optimizer.
+
+
+                         |         USER PASSED TO MinLBFGSOptimize()
+       CREATED WITH      |  function only   |  function and gradient
+       ------------------------------------------------------------
+       MinLBFGSCreateF() |     work                FAIL
+       MinLBFGSCreate()  |     FAIL                work
+
+       Here "FAIL" denotes inappropriate combinations  of  optimizer  creation
+       function  and  MinLBFGSOptimize()  version.   Attemps   to   use   such
+       combination (for example, to create optimizer with MinLBFGSCreateF() and
+       to pass gradient information to MinCGOptimize()) will lead to exception
+       being thrown. Either  you  did  not pass gradient when it WAS needed or
+       you passed gradient when it was NOT needed.
 
       -- ALGLIB --
@@ -316,4 +1892,26 @@
 
     *************************************************************************/
+    public static void minlbfgsoptimize(minlbfgsstate state, ndimensional_func func, ndimensional_rep rep, object obj)
+    {
+        if( func==null )
+            throw new alglibexception("ALGLIB: error in 'minlbfgsoptimize()' (func is null)");
+        while( alglib.minlbfgsiteration(state) )
+        {
+            if( state.needf )
+            {
+                func(state.x, ref state.innerobj.f, obj);
+                continue;
+            }
+            if( state.innerobj.xupdated )
+            {
+                if( rep!=null )
+                    rep(state.innerobj.x, state.innerobj.f, obj);
+                continue;
+            }
+            throw new alglibexception("ALGLIB: error in 'minlbfgsoptimize' (some derivatives were not provided?)");
+        }
+    }
+
+
     public static void minlbfgsoptimize(minlbfgsstate state, ndimensional_grad grad, ndimensional_rep rep, object obj)
     {
@@ -409,4 +2007,338 @@
 
         minlbfgs.minlbfgsrestartfrom(state.innerobj, x);
+        return;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
+    This object stores nonlinear optimizer state.
+    You should use functions provided by MinQP subpackage to work with this
+    object
+    *************************************************************************/
+    public class minqpstate
+    {
+        //
+        // Public declarations
+        //
+
+        public minqpstate()
+        {
+            _innerobj = new minqp.minqpstate();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private minqp.minqpstate _innerobj;
+        public minqp.minqpstate innerobj { get { return _innerobj; } }
+        public minqpstate(minqp.minqpstate obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+
+    /*************************************************************************
+    This structure stores optimization report:
+    * InnerIterationsCount      number of inner iterations
+    * OuterIterationsCount      number of outer iterations
+    * NCholesky                 number of Cholesky decomposition
+    * NMV                       number of matrix-vector products
+                                (only products calculated as part of iterative
+                                process are counted)
+    * TerminationType           completion code (see below)
+
+    Completion codes:
+    * -5    inappropriate solver was used:
+            * Cholesky solver for semidefinite or indefinite problems
+            * Cholesky solver for problems with non-boundary constraints
+    * -3    inconsistent constraints (or, maybe, feasible point is
+            too hard to find). If you are sure that constraints are feasible,
+            try to restart optimizer with better initial approximation.
+    *  4    successful completion
+    *  5    MaxIts steps was taken
+    *  7    stopping conditions are too stringent,
+            further improvement is impossible,
+            X contains best point found so far.
+    *************************************************************************/
+    public class minqpreport
+    {
+        //
+        // Public declarations
+        //
+        public int inneriterationscount { get { return _innerobj.inneriterationscount; } set { _innerobj.inneriterationscount = value; } }
+        public int outeriterationscount { get { return _innerobj.outeriterationscount; } set { _innerobj.outeriterationscount = value; } }
+        public int nmv { get { return _innerobj.nmv; } set { _innerobj.nmv = value; } }
+        public int ncholesky { get { return _innerobj.ncholesky; } set { _innerobj.ncholesky = value; } }
+        public int terminationtype { get { return _innerobj.terminationtype; } set { _innerobj.terminationtype = value; } }
+
+        public minqpreport()
+        {
+            _innerobj = new minqp.minqpreport();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private minqp.minqpreport _innerobj;
+        public minqp.minqpreport innerobj { get { return _innerobj; } }
+        public minqpreport(minqp.minqpreport obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+    /*************************************************************************
+                        CONSTRAINED QUADRATIC PROGRAMMING
+
+    The subroutine creates QP optimizer. After initial creation,  it  contains
+    default optimization problem with zero quadratic and linear terms  and  no
+    constraints. You should set quadratic/linear terms with calls to functions
+    provided by MinQP subpackage.
+
+    INPUT PARAMETERS:
+        N       -   problem size
+
+    OUTPUT PARAMETERS:
+        State   -   optimizer with zero quadratic/linear terms
+                    and no constraints
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpcreate(int n, out minqpstate state)
+    {
+        state = new minqpstate();
+        minqp.minqpcreate(n, state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets linear term for QP solver.
+
+    By default, linear term is zero.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        B       -   linear term, array[N].
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetlinearterm(minqpstate state, double[] b)
+    {
+
+        minqp.minqpsetlinearterm(state.innerobj, b);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets quadratic term for QP solver.
+
+    By default quadratic term is zero.
+
+    IMPORTANT: this solver minimizes following  function:
+        f(x) = 0.5*x'*A*x + b'*x.
+    Note that quadratic term has 0.5 before it. So if  you  want  to  minimize
+        f(x) = x^2 + x
+    you should rewrite your problem as follows:
+        f(x) = 0.5*(2*x^2) + x
+    and your matrix A will be equal to [[2.0]], not to [[1.0]]
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        A       -   matrix, array[N,N]
+        IsUpper -   (optional) storage type:
+                    * if True, symmetric matrix  A  is  given  by  its  upper
+                      triangle, and the lower triangle isnt used
+                    * if False, symmetric matrix  A  is  given  by  its lower
+                      triangle, and the upper triangle isnt used
+                    * if not given, both lower and upper  triangles  must  be
+                      filled.
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetquadraticterm(minqpstate state, double[,] a, bool isupper)
+    {
+
+        minqp.minqpsetquadraticterm(state.innerobj, a, isupper);
+        return;
+    }
+    public static void minqpsetquadraticterm(minqpstate state, double[,] a)
+    {
+        bool isupper;
+        if( !alglib.ap.issymmetric(a) )
+            throw new alglibexception("'a' parameter is not symmetric matrix");
+
+        isupper = false;
+        minqp.minqpsetquadraticterm(state.innerobj, a, isupper);
+
+        return;
+    }
+
+    /*************************************************************************
+    This function sets starting point for QP solver. It is useful to have
+    good initial approximation to the solution, because it will increase
+    speed of convergence and identification of active constraints.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        X       -   starting point, array[N].
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetstartingpoint(minqpstate state, double[] x)
+    {
+
+        minqp.minqpsetstartingpoint(state.innerobj, x);
+        return;
+    }
+
+    /*************************************************************************
+    This  function sets origin for QP solver. By default, following QP program
+    is solved:
+
+        min(0.5*x'*A*x+b'*x)
+
+    This function allows to solve different problem:
+
+        min(0.5*(x-x_origin)'*A*(x-x_origin)+b'*(x-x_origin))
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        XOrigin -   origin, array[N].
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetorigin(minqpstate state, double[] xorigin)
+    {
+
+        minqp.minqpsetorigin(state.innerobj, xorigin);
+        return;
+    }
+
+    /*************************************************************************
+    This function tells solver to use Cholesky-based algorithm.
+
+    Cholesky-based algorithm can be used when:
+    * problem is convex
+    * there is no constraints or only boundary constraints are present
+
+    This algorithm has O(N^3) complexity for unconstrained problem and  is  up
+    to several times slower on bound constrained  problems  (these  additional
+    iterations are needed to identify active constraints).
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetalgocholesky(minqpstate state)
+    {
+
+        minqp.minqpsetalgocholesky(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets boundary constraints for QP solver
+
+    Boundary constraints are inactive by default (after initial creation).
+    After  being  set,  they  are  preserved  until explicitly turned off with
+    another SetBC() call.
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        BndL    -   lower bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very small number or -INF (latter is recommended because
+                    it will allow solver to use better algorithm).
+        BndU    -   upper bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very large number or +INF (latter is recommended because
+                    it will allow solver to use better algorithm).
+
+    NOTE: it is possible to specify BndL[i]=BndU[i]. In this case I-th
+    variable will be "frozen" at X[i]=BndL[i]=BndU[i].
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpsetbc(minqpstate state, double[] bndl, double[] bndu)
+    {
+
+        minqp.minqpsetbc(state.innerobj, bndl, bndu);
+        return;
+    }
+
+    /*************************************************************************
+    This function solves quadratic programming problem.
+    You should call it after setting solver options with MinQPSet...() calls.
+
+    INPUT PARAMETERS:
+        State   -   algorithm state
+
+    You should use MinQPResults() function to access results after calls
+    to this function.
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpoptimize(minqpstate state)
+    {
+
+        minqp.minqpoptimize(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    QP solver results
+
+    INPUT PARAMETERS:
+        State   -   algorithm state
+
+    OUTPUT PARAMETERS:
+        X       -   array[0..N-1], solution
+        Rep     -   optimization report. You should check Rep.TerminationType,
+                    which contains completion code, and you may check  another
+                    fields which contain another information  about  algorithm
+                    functioning.
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpresults(minqpstate state, out double[] x, out minqpreport rep)
+    {
+        x = new double[0];
+        rep = new minqpreport();
+        minqp.minqpresults(state.innerobj, ref x, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    QP results
+
+    Buffered implementation of MinQPResults() which uses pre-allocated  buffer
+    to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
+    intended to be used in the inner cycles of performance critical algorithms
+    where array reallocation penalty is too large to be ignored.
+
+      -- ALGLIB --
+         Copyright 11.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minqpresultsbuf(minqpstate state, ref double[] x, minqpreport rep)
+    {
+
+        minqp.minqpresultsbuf(state.innerobj, ref x, rep.innerobj);
         return;
     }
